public class AVmodell implements Modell
{
    //MIT Dämpfung!
    double m = 0.422+0.337;
    double D    = 3.7982286;
    double Drot = 5.0874992;
    double PP   = 0.0329669;
    double r = 0.08;

    //Flacher Quader der Kantenlänge 2r:
    double J = m*(2*r*2*r)/6;

    public double pwmA = 22.0;
    public double pwmB = -5.0;

    double FA0 = 0.0;
    //FB0 = -10.0;
    double FB0 = 0.0;  //Vorwärtsantrieb

    public int getGleichungsanzahl()
    {
        return 6;      
    }      
    
    public void steigung(double[] f, double[] yy,double t)
    {
        double x   = yy[0];
        double vx  = yy[1];
        double y   = yy[2];
        double vy  = yy[3];
        double phi = yy[4];
        double w   = yy[5];


        double v  = 0;
    
        if (Math.sin(phi)>-0.1 & Math.sin(phi)<0.1)
        {
            v =   vy/Math.cos(phi);
        }    
        else
        {
            v = - vx/Math.sin(phi);
        }

        FA0 = PP*pwmA;
        FB0 = PP*pwmB;

        //Dämpfung hinzufügen
        double FA  = FA0  - D*v + Drot*w*r;
        double FB  = FB0  - D*v - Drot*w*r;

        double FQ  = -m*v*w; 
        double FQx = FQ*Math.cos(phi);
        double FQy = FQ*Math.sin(phi);

        f[0] = vx;
        f[1] = (-FA*Math.sin(phi)-FB*Math.sin(phi)+FQx)/m;
        f[2] = vy;
        f[3] = (FA*Math.cos(phi)+FB*Math.cos(phi)+FQy)/m;
        f[4] = w;
        f[5] = (-r*FA+r*FB)/J;        
    }    
}
