//Zielpunkt anfahren
//Kompass emulieren

Integrator integrator;
AVmodell   modell;

double dt = 0.05;
double  t = 0.0;
double ttot = 0.152;

double[] y;
double[] y0;
double[] y_alt;

double[] pwmA_tot = new double[(int)(ttot/dt)];
double[] pwmB_tot = new double[(int)(ttot/dt)];
int tot_index=0;

//Zielpunkt:
double ziel_x = 0.3; 
double ziel_y = 0.3; 
//In der Hardware durch Aufintegration rekonstrukierte aktuelle Position:
double POSX = 0.0;
double POSY = 0.0;
double POSX_alt = 0.0;
double POSY_alt = 0.0;
double BETA_integ = 0.0; //Aufintegration der Winkel-Regeldifferenz
double EX=0.0;
double EY=0.0;

void initialisieren()
{  
    modell = new AVmodell();
    y = new double[modell.anzahl];
    y0 = new double[modell.anzahl];
    y_alt = new double[modell.anzahl];
    integrator = new Integrator(modell);
}

//Der Regler wird später hier in der zeitschritt()-Methode implementiert.
//Aus dem aktuellen Zustand des Systems wird dazu die Stellgrösse pwmA und pwmB neu bestimmt:
void zeitschritt()
{
    //Vorbereitend werden hier schon die Systemzustände bereitgestellt und die Totzeit berücksichtigt:
    double x     = y[0]; 
    double vx    = y[1]; 
    double yy    = y[2]; 
    double vy    = y[3]; 
    double phi   = y[4]; 
    double omega = y[5]; 

    int pwmA_akt = 0; //nur stufenweise einstellbar wie in Hardware!
    int pwmB_akt = 0;
  
    //Vorwärtsgeschwindigkeit hier extra bestimmen:
    double v = 0.0;
    if (Math.sin(phi)>-0.1 & Math.sin(phi)<0.1)
    {
        v =   vy/Math.cos(phi);
    }    
    else
    {
        v = - vx/Math.sin(phi);
    }

    //*******************************************
    //Versuch Hardware abzubilden:
    //Kompass liefert Nordrichtung in RAD, allerdings nur Wertebereich von 0..2PI !
    //hier: positive y-Richtung ist Norden.
    double phi_k = phi;
    while(phi_k>2.0*Math.PI)
        phi_k-=2.0*Math.PI;
    while(phi_k<0.0)
        phi_k+=2.0*Math.PI;
        
        
    //Versuch in der Hardware aus der Vorwärtsgeschwindigkeit und 
    //dem Kompasswinkel die aktuelle Position aufzuintegrieren:
    POSX_alt = POSX; 
    POSY_alt = POSY; 
    
    POSX += v*-Math.sin(phi_k)*dt;
    POSY += v*Math.cos(phi_k)*dt;

    //Verbindungsvektor zwischen Zielpunkt und aktueller Position bilden:
    double xdiff = ziel_x - POSX;
    double ydiff = ziel_y - POSY;

    //Vektorlänge:
    double laenge = Math.sqrt(xdiff*xdiff+ydiff*ydiff);

    //Solange eine kleine positive Geschwindigkeit beibehalten, solange die Annäherung an den Zielpunkt
    //kleiner als 0.01m ist:
    double PWM_VOR = 0.0;  //Vorwärtsanteil des PWM-Signals
    double PWM_DREH = 0.0; //rotatorischer Anteil des PWM-Signals
    boolean ZIELERREICHT = false;
    if(laenge>0.01)
    {
        PWM_VOR = 10.0;
    }        
    else
    {
        ZIELERREICHT = true;
        PWM_VOR = 0.0;
        PWM_DREH = 0.0;
        BETA_integ=0.0; //sicherheitshalber
    }
    
    if(ZIELERREICHT==false)
    {    
       //*******************************************
       //Solange die eigene aktuelle Orientierung mehr als 90 Grad von der Sollrichtung abweicht, einfach auf der 
       //Stelle drehen:
       //Dazu Einheitsvektor der aktuellen Orientierung bilden:
       EX = -Math.sin(phi_k);
       EY =  Math.cos(phi_k);
       
       double EXD = xdiff/laenge;  //Normierung des Differenzvektors
       double EYD = ydiff/laenge;
       
       //BETA soll der Winkel VON der aktuellen Orientierung ZU der Sollorientierung sein.
       
       //Cosinussatz cos(beta) = (a*b)/(|a|*|b|)
       //Gültigkeitsbereich: 0..180 Grad
       double COSBETA = EX*EXD+EY*EYD;
       
       double BETA = Math.acos(COSBETA);
       //Fallunterscheidung
       //BETA soll der Winkel VON der aktuellen Orientierung ZU der Sollorientierung sein.
       if(-EYD*EX+EXD*EY>0.0)
           BETA=-BETA;
           
       if(BETA>0.5*Math.PI)
       {
           PWM_DREH = -10.0;
           BETA_integ=0.0;
       }
       else if(BETA<-0.5*Math.PI)
       {
           PWM_DREH = 10.0;
           BETA_integ=0.0;
       }
       else
       {
           //Hier nun den PI-Regler für Winkel phi nach Ziegler-Nichols implementieren:
           PWM_DREH = 46.8*BETA  + 68.82*BETA_integ;
           
           //erst hier BETA aufintegrieren!
           BETA_integ+=BETA*dt; //es muss also auch beim realen System ein definiertes dt geben!
       }
   
       System.out.println("BETA="+BETA*180.0/Math.PI+"GRad PWM_DREH="+PWM_DREH);    
    }
  
    pwmA_akt = (int)(PWM_VOR - PWM_DREH);
    pwmB_akt = (int)(PWM_VOR + PWM_DREH);
    
    //Begrenzen auf erlaubten Bereich:
    if(pwmA_akt>22)
        pwmA_akt=22;
    if(pwmA_akt<-22)
        pwmA_akt=-22;
    if(pwmB_akt>22)
        pwmB_akt=22;
    if(pwmB_akt<-22)
        pwmB_akt=-22;
  
     //Handling der Totzeit: pwm-Signal wird verzögert weitergegeben:  
    pwmA_tot[tot_index] = (double)pwmA_akt;
    pwmB_tot[tot_index] = (double)pwmB_akt;
  
    modell.pwmA = pwmA_tot[(tot_index+1)%pwmA_tot.length];
    modell.pwmB = pwmB_tot[(tot_index+1)%pwmB_tot.length];
   
//    System.out.print("t="+t+" ");   
//    for(int i=0;i<y.length;i++)
//    {
//        System.out.print("y"+i+"="+y[i]+" ");   
//    }
//    System.out.println();

    for(int i=0;i<y.length;i++)
        y_alt[i] = y[i];
  
    integrator.zeitschritt(y,y_alt,t,dt); //Ergebnis wird in y gelegt
    
    t+=dt;
    tot_index++;
    tot_index%=pwmA_tot.length;   
}


void setup()
{
    initialisieren();
    size(800,800);
    clear();
    noFill();
    stroke(255);    
    background(0);
    frameRate(10);
}

void draw()
{
    zeitschritt();
    strokeWeight(0.001f);
    translate(width/2.0f,height/2.0f);
    scale(1000.0f);

    //10-Zentimeter-Raster einzeichnen:
    stroke(200,255,200);
    for(int i=0;i<21;i++)
        for(int k=0;k<21;k++)
            rect(0.1*(float)(k-10),0.1*(float)(i-10),0.1f,0.1f);


    
    //Koordinatenkreuz zeichnen (+/-1m):
    stroke(255,200,200);
    line(0.0f,-1.0f,0.0f,1.0f);
    line(-1.0f,0.0f,1.0f,0.0f);
 
    //Zielposition einzeichnen:
    stroke(255,0,0);
    
    ellipse((float)ziel_x,-(float)ziel_y,0.02f,0.02f);   
    
    //Koordinaten transponieren
    float xx = (float)y[0];
    float yy = -(float)y[2];
    float xx_alt = (float)y[0];
    float yy_alt = -(float)y[2];

    //aktuelle Richtung mit einzeichnen: GELB
    stroke(255,255,0);
    line(xx,yy,xx+(float)EX*0.03f,yy-(float)EY*0.03f);

    
    stroke(255);
    line(xx_alt,yy_alt,xx,yy);

    //Testweise die rekonstruierten Koordinaten mit darstellen
    stroke(100,100,255);
    line((float)POSX_alt,-(float)POSY_alt,(float)POSX,-(float)POSY);

    scale(0.001f);
    translate(-width/2.0f,-height/2.0f);
    
}

void mouseClicked()
{
    clear();
    background(0);
    initialisieren();       
}
